;
; BASICvONp
;

	relaxed on

	include	"header.asm"

	org	$de00

	jp	GAMESTART	; 0xde00
	jp	SETBANK		; 0xde03
	jp	RAMCHECK	; 0xde06

LDBANK:	db	$00		; 0xde09


RAMCHECK:
	di

	ld	a,$20		; 0x0000`0xBFFF̓ǂݏoOɂ
	call	RDBANK
	add	a,2
	out	($64),a
	add	a,2
	out	($65),a

	ld	a,$20		; 0x0000`0xBFFF݂̏Oɂ
	call	WRBANK
	add	a,2
	out	($6c),a
	add	a,2
	out	($6d),a
;
; OtRAM̃`FbN
;
	ld	bc,$5aa5
	ld	d,$96
	ld	hl,$0000
	ld	(hl),b
	ld	h,$40
	ld	(hl),c
	ld	h,$80
	ld	(hl),d

	ld	h,$00
	ld	a,(hl)
	cp	b
	call	nz,RAMERR
	ld	h,$40
	ld	a,(hl)
	cp	c
	call	nz,RAMERR
	ld	h,$80
	ld	a,(hl)
	cp	d
	call	nz,RAMERR

	ld	a,$f8		; 0x8000`0x7FFF̓ǂݏoN66SR-BASICɂ
	call	RDBANK
	ld	a,$08		; 0x8000`0xBFFF̓ǂݏoɂ
	out	($64),a
	add	a,2
	out	($65),a

	ld	a,$00		; 0x0000`0xBFFF݂̏ɂ
	call	WRBANK
	add	a,2
	out	($6c),a
	add	a,2
	out	($6d),a

	ei
	ret

;
; 0x0000`0x3FFF̃oNZbg
;
SETBANK:
	ld	a,(LDBANK)
	add	a,a
	add	a,a
	or	$20		; 0x0000`0x3FFF݂̏Oɂ
	out	($68),a
	add	a,2
	out	($69),a
	ret

;
; Q[X^[g
;
GAMESTART:

;
; BIOS]
;
	di

	ld	a,$20		; 0x0000`0x7FFF̓ǂݏoOɂ
	call	RDBANK
	ld	a,$20		; 0x0000`0x7FFF݂̏Oɂ
	call	WRBANK

	ld	hl,$a000
	ld	de,$e000
	ld	bc,BIOS_SIZE	; BIOS̃TCY
	ldir

;
; VXȅ
;
SYSINIT:
	im	2
	ld	a,$e0
	ld	i,a		; 荞݃e[u0xe000`ɐݒ

	ld	a,$ee		; 荞݂VSYNCASUB-CPÛ݂ɂ
	out	($fa),a

;	ld	a,$7f
;	out	($f6),a		; ^C}̊荞݊Ԋu2msɂ
;
;	ld	a,$f6
;	out	($b0),a		; ^C}荞ON

	ld	a,$02
	out	($93),a		; ʂ

	ld	a,$fb		; CSS3-1=011
	out	($c0),a

	ld	a,$fb		; 320x200 OtBbN
	out	($c1),a

	ld	a,$e6		; rbg}bv[hɐݒ^y[WO\
	out	($c8),a

	ld	bc,$07c9
	xor	a
.outlp2:
	out	(c),a
				; 0xC9:VRAM}bv̐ݒ
				; 0xCA:XN[XW̐ݒ
				; 0xCB:XN[XW̐ݒ
				; 0xCC:XN[YW̐ݒ
				; 0xCD:XN[YW̐ݒ
				; 0xCE:YWiʁj̐ݒ
				; 0xCF:YWiʁj̐ݒ
	inc	c
	djnz	.outlp2

				; pbg̐ݒ
	ld	a,$08!$0f
	out	($40),a
	out	($41),a
	out	($42),a
	out	($43),a

	ld	a,240		; 320 - (320-160)/2
	out	($ca),a		; XN[XW
	ld	a,176		; 204 - (200-144)/2
	out	($cc),a		; XN[YW

	call	VRAMCLR

	ld	a,$03
	out	($93),a		; ʂ\

	ld	de,$07bf	; ~LT[FSďo͂Ȃ
	call	OUTOPN

	ld	b,3
	ld	de,$0800	; `l``b̉
.lp1:	call	OUTOPN
	inc	d
	djnz	.lp1

	ld	b,3
	ld	de,$2800	; S`lL[It
.lp2:	call	OUTOPN
	inc	e
	djnz	.lp2

	ld	sp,$efff

	jp	$0150


;
; VRAMNAiOtBbNj
;
VRAMCLR:
	ld	a,$00		; 0x0000`0x7FFF̓ǂݏoɂ
	call	RDBANK
	ld	a,$00		; 0x0000`0x7FFF݂̏ɂ
	call	WRBANK

	ld	c,$00
.lp3:
	ld	a,c
	out	($ce),a

	ld	hl,$0000

	ld	b,160
	ld	a,c
	cp	144
	ld	a,$0f		; 
	jr	c,.ld1
	ld	a,COL_B
.ld1:
.lp1:
	ld	(hl),a
	inc	hl
	djnz	.lp1

	ld	b,160
	ld	a,COL_B
.lp2:
	ld	(hl),a
	inc	hl
	djnz	.lp2

	inc	c
	ld	a,c
	cp	204
	jr	nz,.lp3

	ld	a,$20		; 0x0000`0x7FFF̓ǂݏoOɂ
	call	RDBANK
	ld	a,$20		; 0x0000`0x7FFF݂̏Oɂ
	call	WRBANK

	ret


;
; ʃNAiLN^j
;
CURCLS:
	ld	hl,$f000
	ld	(hl),$20
	inc	hl
	ld	(hl),$0f
	inc	hl
	ld	de,$f000
	ex	de,hl
	ld	bc,40*25*2-1
	ldir
	ret

;
; \
;
PNT_MSG:
.msglp:
	ld	a,(de)
	inc	de
	or	a
	ret	z
	ld	(hl),a
	inc	hl
	inc	hl
	jr	.msglp

;
; RAMG[
;
RAMERR:
	call	CURCLS
	ld	a,$0e
	out	($6f),a		; 0xE000`0xFFFFRAM߂
	ld	de,RAMNG_MSG
	ld	hl,$f000
	call	PNT_MSG
	jr	$

RAMNG_MSG:
	db	"64K",$e9,$20				; USj
	db	"RAM",$96,$de,$20			; q`lJ
	db	$eb,$e2,$f6,$93,$e3,$de,$9d,$a1,$00	; Ђ悤āJB


;
; OPNɏo͂
; DFAhX
; EFf[^
;
OUTOPN:
	ld	a,d
	out	($a0),a

.lp1:	in	a,($a3)
	rlca
	jr	c,.lp1

	ld	a,e
	out	($a1),a

.lp2:	in	a,($a3)
	rlca
	jr	c,.lp2

	ret

;
; ݃oNݒ
;
WRBANK:
	out	($68),a
	add	a,2
	out	($69),a
	add	a,2
	out	($6a),a
	add	a,2
	out	($6b),a
	ret

;
; ǂݏooNݒ
;
RDBANK:
	out	($60),a
	add	a,2
	out	($61),a
	add	a,2
	out	($62),a
	add	a,2
	out	($63),a
	ret


end

